-- multiplayer crap


function Bikinitools:transmitObject(object)
	if isClient()
	then
		object:transmitCompleteItemToServer();
	else
		object:transmitCompleteItemToClients();
	end
end


function Bikinitools:sendClientCommand(cType, command, args)
	return sendClientCommand(Bikinitools:getPlayer(), cType, command, args);
end


-- data handling


function Bikinitools:getFieldValue(object, field)
	for i = 0, getNumClassFields(object) - 1
	do
		local fld = getClassField(object, i);

		if fld and Bikinitools:getStringFromLastOccurenceOfChar(fld, ".") == field
		then
			return getClassFieldVal(object, fld);
		end
	end

	return nil;
end


function Bikinitools:getStringFromLastOccurenceOfChar(str, chr)
	str = KahluaUtil.rawTostring2(str);

	if chr
	then
		return str:sub(1 - (str:reverse()):find("%" .. chr));
		--return str:match('[^' .. chr .. ']+$');
	end

	return nil;
end


function Bikinitools:valueIsInArray(array, value)
    for i, aValue in ipairs(array)
    do
        if aValue == value
        then
            return true;
        end
    end

    return false;
end


function Bikinitools:sortArrayByValue(array, byFirstLetter)
    table.sort(array,
        function(a, b)
            if not byFirstLetter
            then
                return not string.sort(a, b);
            else
                return not string.sort(Bikinitools:getFirstLetter(a), Bikinitools:getFirstLetter(b));
            end
        end
    );

    return array;
end


function Bikinitools:sortArrayByKey(array)
    local keys = {};

    for key in pairs(array)
    do
        table.insert(keys, key);
    end

    table.sort(keys);

    local result = {};

    for i, key in ipairs(keys)
    do
        result[key] = array[key];
    end

    return result;
end


function Bikinitools:isFunction(var)
    if type(var) == "function"
    then
        return true;
    else
        return false;
    end
end


function Bikinitools:splitString(srcString, separator)
    local fragments = {};

    for fragment in srcString:gmatch("([^" .. separator .. "]+)")
    do
        table.insert(fragments, fragment);
    end

    return fragments;
end


function Bikinitools:splitEachArrayItemBySeparator(array, splitStr)
    for i, item in ipairs(array)
    do
        array[i] = Bikinitools:splitString(item, splitStr);
    end

    return array;
end


function Bikinitools:getFirstLetter(srcString)
    local firstLetter = "?";

    for letter in string.gmatch(srcString, "%a")
    do
        firstLetter = letter;

        break;
    end

    if not firstLetter
    then
        firstLetter = srcString:match("[%z\1-\127\194-\244][\128-\191]*");
    end

    return firstLetter;
end


function Bikinitools:trimString(srcString)
    return srcString:match "^%s*(.-)%s*$";
end


function Bikinitools:ucFirst(srcString)
    return srcString:gsub("^%l", string.upper);
end


function Bikinitools:ternary(condition, ifTrue, ifFalse)
    if condition
    then
        return ifTrue;
    else
        return ifFalse;
    end
end


function Bikinitools:countArrayElements(array)
    local count = 0;

    for key, value in pairs(array)
    do
        count = count + 1;
    end

    return count;
end


function Bikinitools:concatArrays(array1, array2)
	if not array2
	then
		return array1;
	end

	for i, item in ipairs(array2)
	do
		table.insert(array1, item);
	end

	return array1;
end


function Bikinitools:reverseArray(array)
	local size = #array;

	for i = size - 1, 1, -1
	do
		array[size] = table.remove(array, i);
	end

	return array;
end


function Bikinitools:copyArray(array)
	local copy = {};

	for i, item in ipairs(array)
	do
		table.insert(copy, item);
	end

	return copy;
end