-- config


Bikinitools.Options:register("enableTrunkUnlocker", false);


-- methods


function Bikinitools.Vehicle.unlockTrunk(vehicle)
    if vehicle
    then
		vehicle:setTrunkLocked(false);

		--Commands.setTrunkLocked(Bikinitools:getPlayer(), {
			--locked = false
		--});

		Bikinitools:sendClientCommand("vehicle", "setTrunkLocked", {
			locked = false
		});

		if not vehicle:isTrunkLocked()
        then
			Bikinitools:message(getText("IGUI_bikinitools_V_TrunkUnlocked"));
        else
            Bikinitools:message(getText("IGUI_bikinitools_V_OpenDoorFail"));
        end
    end
end


-- context menu helper


function Bikinitools.Vehicle:addTrunkUnlockerContextMenuEntry(contextMenu, attachedObject, vehicle)
    if vehicle:getPartCount() > 0 and vehicle:isTrunkLocked()
    then
		Bikinitools:addContextMenuItem(contextMenu,
			getText("IGUI_bikinitools_V_UnlockTrunk"),
			Bikinitools.Vehicle.unlockTrunk, {
				vehicle
			}
		);
    end
end